<template>
	<div>
		<div class="cards">
			<h4>Event hinzuf&uuml;gen</h4>
			<div class="card-body">
				<form v-on:submit.prevent class="cols c-0-1 mobile-flex">
					<div class="cell">Titel</div>
					<div class="cell">
						<input ref="title"  v-model="form.title" type="text" class="input" required />
					</div>
					<div class="cell">Typ</div>
					<div class="cell">
						<select ref="eventTypeId" v-model="form.eventTypeId" class="input" required>
							<option v-for="eventType in allEventTypes" :key="eventType.id" :value="eventType.id">
								{{ eventType.title }}
							</option>
						</select>
					</div>
					<div class="cell">Start</div>
					<div class="cell">
						<input @change="forceDateCorrection" ref="dateStart" v-model="form.dateStart" class="input" type="date" name="dateStart" required />
					</div>
					<div class="cell">Ende</div>
					<div class="cell">
						<input @change="forceDateCorrection" ref="dateEnd" v-model="form.dateEnd" class="input" type="date" name="dateEnd" required />
					</div>
					<div class="cell">Einlass</div>
					<div class="cell">
						<input ref="doorsOpen" v-model="form.doorsOpen" class="input" type="time" name="doorsOpen" required />
					</div>
					<div class="cell">Preis</div>
					<div class="cell">
						<input ref="price" v-model="form.price" class="input" type="number" name="price" required />
					</div>
					<div class="cell">Flyer</div>
					<div class="cell">
						<input ref="image" @change="uploadFlyer" class="input" type="file" name="image" required />
						<img v-if="previewFlyerSrc" :src="previewFlyerSrc" title="Flyer Preview" alt="Flyer preview" class="flyer-upload-preview" />
					</div>
					<div class="cell">Text</div>
					<div class="cell">
						<textarea ref="text" v-model="form.text" class="input input--full-w" name="text" required></textarea>
					</div>

					<div class="cell c-merged">
						<button @click="postEvent" type="submit" class="button button--mobile-stretch">Speichern</button>
					</div>
				</form>
			</div>
		</div>

		<system-message v-if="sysMsg" :msg.sync="sysMsg" />
	</div>

</template>

<script>
import SystemMessage from "@/components/SystemMessage";

export default {
	name: "AdminEventsNew",
	components: { SystemMessage },
	props: {
		setDate: String
	},
	data: () => ({
		form: {
			title: "",
			eventTypeId: "",
			dateStart: "",
			dateEnd: "",
			doorsOpen: "",
			price: "",
			image: "",
			text: ""
		},
		previewFlyerSrc: "",
		sysMsg: undefined
	}),
	methods: {
		async postEvent() {
			this.sysMsg = "";

			let verified = this.globalValidateForm();
			if (!verified) {
				this.sysMsg = "Fehlende Eingaben!";
				return;
			}

			if(this.form.doorsOpen.length < 8) {
				this.form.doorsOpen += ":00";
			}

			try {
				const response = await this.$http.post("/api/admin/events/post", this.form);
				switch (response.status) {
					case 201:
						this.globalEmptyForm();
						this.$refs.image.value
							= this.previewFlyerSrc
							= "";
						this.sysMsg = "Event erfolgreich eingetragen!";
						await this.$store.dispatch("getAllEvents");
						break;
					case 202:
						this.sysMsg = "Datum nicht verfügbar!";
						this.$refs.dateStart.classList.add("input--alert");
						this.$refs.dateEnd.classList.add("input--alert");
						this.$refs.dateStart.focus();
						break;
				}
			} catch (e) {
				switch (e.response.status) {
					case 406:
						this.sysMsg = "Ungültige Zeitspanne!";
						this.$refs.dateStart.classList.add("input--alert");
						this.$refs.dateEnd.classList.add("input--alert");
						this.$refs.dateStart.focus();
						break;
					case 500:
						console.log(e.response);
						break;
				}

			}
		},

		async uploadFlyer() {
			this.sysMsg = "";
			const file = this.$refs.image.files[0];
			let formData = new FormData();
			formData.append("file", file);

			try {
				const response = await this.$http.post("/api/admin/events/upload", formData)

				switch (response.status) {
					case 200:
						this.sysMsg = "Flyer erfolgreich hochgeladen!";
						this.previewFlyerSrc = this.baseUrl + "/program/" + file.name;
						this.form.image = file.name;
						this.$refs.image.classList.remove("input--alert");
						await this.$store.dispatch("getAllEvents");
						break;
				}
			} catch (e) {
				switch (e.response.status) {
					case 413:
						this.sysMsg = "Datei ist zu groß!";
						this.$refs.image.classList.add("input--alert");
						this.$refs.image.value = "";
						break;
				}
			}
		},

		forceDateCorrection() {
			let dateStart = this.$refs.dateStart;
			let dateEnd = this.$refs.dateEnd;
			if (!!dateStart || !!dateEnd) {
				if (dateStart.value > dateEnd.value) {
					dateEnd.value = dateStart.value;
					this.form.dateEnd = dateStart.value;
				}
			}
		}
	},
	computed: {
		allEventTypes() {
			return this.$store.getters.getAllEventTypes;
		},
		baseUrl() {
			return process.env.VUE_APP_BASE_URL;
		}
	},
	mounted() {
		this.$store.dispatch("getAllEventTypes");

		if (this.setDate) {
			let dateSplit = this.setDate.split("-");
			this.form.dateStart = this.form.dateEnd =
				dateSplit[0] + "-"
				+ (dateSplit[1].length < 2 ? "0" + dateSplit[1] : dateSplit[1])
				+ "-"
				+ (dateSplit[2].length < 2 ? "0" + dateSplit[2] : dateSplit[2])
		}
	}
}
</script>

<style scoped>

</style>